---
title: Create an environment
description: Creates a new environment for organizing feature flags.
breadcrumbs: Docs > API > Create an environment
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create an environment

## v2 (latest)

| Datadog site      | API endpoint                                                         |
| ----------------- | -------------------------------------------------------------------- |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/feature-flags/environments     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/feature-flags/environments |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/feature-flags/environments |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/feature-flags/environments      |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/feature-flags/environments |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/feature-flags/environments |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/feature-flags/environments |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/feature-flags/environments      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/feature-flags/environments  |

### Overview

Creates a new environment for organizing feature flags.

This endpoint requires the `feature_flag_environment_config_write` permission.

OAuth apps require the `feature_flag_environment_config_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#feature-flags) to access this endpoint.

### Request

#### Body Data (required)

{% tabs %}
{% tab label="Model" %}
| Parent field | Field                         | Type     | Description                                                                                                                                                                                                                                                            |
| ------------ | ----------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]             | object   | Data for creating a new environment.                                                                                                                                                                                                                                   |
| data         | attributes [*required*]       | object   | Attributes for creating a new environment.                                                                                                                                                                                                                             |
| attributes   | is_production                 | boolean  | Indicates whether this is a production environment. Default: `false`.                                                                                                                                                                                                  |
| attributes   | name [*required*]             | string   | The name of the environment. Required on every request and unique within the organization. Must contain 1 to 200 ASCII characters, start with a letter or digit, and contain only letters, digits, spaces, underscores, hyphens, and periods.                          |
| attributes   | observe_full_evaluation_data  | boolean  | Controls whether feature flag evaluation events may include original targeting identifiers and full evaluation context. When true, SDKs may include this data. When false, SDKs hash targeting identifiers and omit evaluation context. If omitted, defaults to false. |
| attributes   | queries [*required*]          | [string] | Required list of at least one exact DD_ENV value associated with this environment. Values cannot be used by another environment in the same organization. Wildcards and search expressions are not supported.                                                          |
| attributes   | require_feature_flag_approval | boolean  | Indicates whether feature flag changes require approval in this environment. Default: `false`.                                                                                                                                                                         |
| data         | type [*required*]             | enum     | The resource type. Allowed enum values: `environments`.                                                                                                                                                                                                                |
{% /tab %}

{% tab label="Example" %}
**Create an environment returns "Created" response**

```json
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Test Environment Example-Feature-Flag",
      "queries": [
        "test-Example-Feature-Flag",
        "env-Example-Feature-Flag"
      ]
    }
  }
}
```

**Create an environment with full evaluation data false returns "Created" response**

```json
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Evaluation Privacy Example-Feature-Flag",
      "queries": [
        "privacy-example-feature-flag"
      ],
      "observe_full_evaluation_data": false
    }
  }
}
```

**Create an environment with full evaluation data true returns "Created" response**

```json
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Evaluation Privacy Example-Feature-Flag",
      "queries": [
        "privacy-example-feature-flag"
      ],
      "observe_full_evaluation_data": true
    }
  }
}
```
{% /tab %}
{% /tabs %}

### Response

{% tabs %}
{% tab label="201" %}
Created

{% tabs %}
{% tab label="Model" %}
Response containing an environment.

| Parent field | Field                         | Type      | Description                                                                                                          |
| ------------ | ----------------------------- | --------- | -------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]             | object    | A feature flag environment resource.                                                                                 |
| data         | attributes [*required*]       | object    | Attributes of an environment.                                                                                        |
| attributes   | created_at                    | date-time | The timestamp when the environment was created.                                                                      |
| attributes   | description                   | string    | The description of the environment.                                                                                  |
| attributes   | is_production                 | boolean   | Indicates whether this is a production environment.                                                                  |
| attributes   | key                           | string    | The unique key of the environment.                                                                                   |
| attributes   | name [*required*]             | string    | The name of the environment.                                                                                         |
| attributes   | observe_full_evaluation_data  | boolean   | Indicates whether feature flag evaluation events include original targeting identifiers and full evaluation context. |
| attributes   | queries                       | [string]  | List of queries to define the environment scope.                                                                     |
| attributes   | require_feature_flag_approval | boolean   | Indicates whether feature flag changes require approval in this environment.                                         |
| attributes   | updated_at                    | date-time | The timestamp when the environment was last updated.                                                                 |
| data         | id [*required*]               | uuid      | The unique identifier of the environment.                                                                            |
| data         | type [*required*]             | enum      | The resource type. Allowed enum values: `environments`.                                                              |
{% /tab %}

{% tab label="Example" %}
```json
{
  "data": {
    "attributes": {
      "created_at": "2023-01-01T00:00:00Z",
      "description": "Test environment XYZ789",
      "is_production": false,
      "key": "env-search-term",
      "name": "env-search-term",
      "observe_full_evaluation_data": false,
      "queries": [
        "staging",
        "test"
      ],
      "require_feature_flag_approval": false,
      "updated_at": "2023-01-01T00:00:00Z"
    },
    "id": "550e8400-e29b-41d4-a716-446655440001",
    "type": "environments"
  }
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="400" %}
Bad Request

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="403" %}
Forbidden

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="409" %}
Conflict

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="429" %}
Too many requests

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}
{% /tabs %}

### Code Example

{% tabs %}
{% tab label="Curl" %}
```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/feature-flags/environments" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Test Environment Example-Feature-Flag",
      "queries": [
        "test-Example-Feature-Flag",
        "env-Example-Feature-Flag"
      ]
    }
  }
}
EOF
```

```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/feature-flags/environments" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Evaluation Privacy Example-Feature-Flag",
      "queries": [
        "privacy-example-feature-flag"
      ],
      "observe_full_evaluation_data": false
    }
  }
}
EOF
```

```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/feature-flags/environments" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "environments",
    "attributes": {
      "name": "Evaluation Privacy Example-Feature-Flag",
      "queries": [
        "privacy-example-feature-flag"
      ],
      "observe_full_evaluation_data": true
    }
  }
}
EOF
```
{% /tab %}

{% tab label="Go" %}
```go
// Create an environment returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.CreateEnvironmentRequest{
		Data: datadogV2.CreateEnvironmentData{
			Type: datadogV2.CREATEENVIRONMENTDATATYPE_ENVIRONMENTS,
			Attributes: datadogV2.CreateEnvironmentAttributes{
				Name: "Test Environment Example-Feature-Flag",
				Queries: []string{
					"test-Example-Feature-Flag",
					"env-Example-Feature-Flag",
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewFeatureFlagsApi(apiClient)
	resp, r, err := api.CreateFeatureFlagsEnvironment(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `FeatureFlagsApi.CreateFeatureFlagsEnvironment`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `FeatureFlagsApi.CreateFeatureFlagsEnvironment`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
```
{% /tab %}

{% tab label="Java" %}
```java
// Create an environment returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.FeatureFlagsApi;
import com.datadog.api.client.v2.model.CreateEnvironmentAttributes;
import com.datadog.api.client.v2.model.CreateEnvironmentData;
import com.datadog.api.client.v2.model.CreateEnvironmentDataType;
import com.datadog.api.client.v2.model.CreateEnvironmentRequest;
import com.datadog.api.client.v2.model.EnvironmentResponse;
import java.util.Arrays;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    FeatureFlagsApi apiInstance = new FeatureFlagsApi(defaultClient);

    CreateEnvironmentRequest body =
        new CreateEnvironmentRequest()
            .data(
                new CreateEnvironmentData()
                    .type(CreateEnvironmentDataType.ENVIRONMENTS)
                    .attributes(
                        new CreateEnvironmentAttributes()
                            .name("Test Environment Example-Feature-Flag")
                            .queries(
                                Arrays.asList(
                                    "test-Example-Feature-Flag", "env-Example-Feature-Flag"))));

    try {
      EnvironmentResponse result = apiInstance.createFeatureFlagsEnvironment(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FeatureFlagsApi#createFeatureFlagsEnvironment");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
```
{% /tab %}

{% tab label="Python" %}
```python
"""
Create an environment returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.feature_flags_api import FeatureFlagsApi
from datadog_api_client.v2.model.create_environment_attributes import CreateEnvironmentAttributes
from datadog_api_client.v2.model.create_environment_data import CreateEnvironmentData
from datadog_api_client.v2.model.create_environment_data_type import CreateEnvironmentDataType
from datadog_api_client.v2.model.create_environment_request import CreateEnvironmentRequest

body = CreateEnvironmentRequest(
    data=CreateEnvironmentData(
        type=CreateEnvironmentDataType.ENVIRONMENTS,
        attributes=CreateEnvironmentAttributes(
            name="Test Environment Example-Feature-Flag",
            queries=[
                "test-Example-Feature-Flag",
                "env-Example-Feature-Flag",
            ],
        ),
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = FeatureFlagsApi(api_client)
    response = api_instance.create_feature_flags_environment(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
```
{% /tab %}

{% tab label="Ruby" %}
```ruby
# Create an environment returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::FeatureFlagsAPI.new

body = DatadogAPIClient::V2::CreateEnvironmentRequest.new({
  data: DatadogAPIClient::V2::CreateEnvironmentData.new({
    type: DatadogAPIClient::V2::CreateEnvironmentDataType::ENVIRONMENTS,
    attributes: DatadogAPIClient::V2::CreateEnvironmentAttributes.new({
      name: "Test Environment Example-Feature-Flag",
      queries: [
        "test-Example-Feature-Flag",
        "env-Example-Feature-Flag",
      ],
    }),
  }),
})
p api_instance.create_feature_flags_environment(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" ruby "example.rb"
```
{% /tab %}

{% tab label="Rust" %}
```rust
// Create an environment returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_feature_flags::FeatureFlagsAPI;
use datadog_api_client::datadogV2::model::CreateEnvironmentAttributes;
use datadog_api_client::datadogV2::model::CreateEnvironmentData;
use datadog_api_client::datadogV2::model::CreateEnvironmentDataType;
use datadog_api_client::datadogV2::model::CreateEnvironmentRequest;

#[tokio::main]
async fn main() {
    let body = CreateEnvironmentRequest::new(CreateEnvironmentData::new(
        CreateEnvironmentAttributes::new(
            "Test Environment Example-Feature-Flag".to_string(),
            vec![
                "test-Example-Feature-Flag".to_string(),
                "env-Example-Feature-Flag".to_string(),
            ],
        ),
        CreateEnvironmentDataType::ENVIRONMENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = FeatureFlagsAPI::with_config(configuration);
    let resp = api.create_feature_flags_environment(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
```
{% /tab %}

{% tab label="TypeScript" %}
```typescript
/**
 * Create an environment returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
const apiInstance = new v2.FeatureFlagsApi(configuration);

const params: v2.FeatureFlagsApiCreateFeatureFlagsEnvironmentRequest = {
  body: {
    data: {
      type: "environments",
      attributes: {
        name: "Test Environment Example-Feature-Flag",
        queries: ["test-Example-Feature-Flag", "env-Example-Feature-Flag"],
      },
    },
  },
};

apiInstance
  .createFeatureFlagsEnvironment(params)
  .then((data: v2.EnvironmentResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" npx tsx "example.ts"
```
{% /tab %}
{% /tabs %}
